#*************************************************************************************************************
# Programm PYKNICK
# 8.4.2021 Rieg
#*************************************************************************************************************
ti= False      # True fuer TI-Nspire, False fuer Windows,Mac & Linux
               
if ti == True:
  from ti_system import clear_history

from math import pi,sqrt

#*************************************************************************************************************
# Function choice
#*************************************************************************************************************
def choice():
  global ikey,il
  
  if ti == True:
    clear_history()
  
  while True:
    print()
    print("Knickungsberechnung,9 Info")
    print("1 Kraft, Stablaenge")
    print("2 Knickfall,Sicherheiten")
    print("3 Rohr/beliebiger Quers.")
    print("4 Material")
    print("6 momentan def. Werte")
    print("7 Compute")
    print("8 Exit")

    key= input("Ihre Wahl: ")
    if key in ("1","2","3","4","6","7","8","9"):
      break
  ikey= int(key)
  key= " "

#*************************************************************************************************************
# Hauptprogramm
#*************************************************************************************************************
choice()

#----------------------------------------------------------------------
#  Startwerte
#----------------------------------------------------------------------
F    = 1000.0
L    = 1000.0
A    = 216.0
I    = 20586.0
Da   = 30.0
Di   = 25.0
E    = 70000.0
Rp   = 200.0
Skeu = 7.0
Sktet= 5.0
imat=  5
irohr= 1
ifall= 2

#----------------------------------------------------------------------
#Endlos-Schleife
#----------------------------------------------------------------------
while True:

#----------------------------------------------------------------------
# i Info
#----------------------------------------------------------------------
  if ikey == 9:
    if ti == True:
      clear_history()
    print()
    print("PYKNICK MK1,Lehrstuhl Konstruktionslehre+CAD,Universitaet Bayreuth,")
    print("Prof.Frank Rieg,8.4.2021,Knickungsberechnung.")  
    key=input("weiter mit Enter-Taste")
    choice()
  
#----------------------------------------------------------------------
#  F1 Kraft, Stablänge
#----------------------------------------------------------------------
  if ikey == 1:
    if ti == True:
      clear_history()
    print()
    print("Eingabewerte 1:")
 
    F= float(input("Kraft F? "))
    L= float(input("Stablänge L? "))
    key=input("weiter mit Enter-Taste")

    choice()

#----------------------------------------------------------------------
#  F2 Knickfall, Sicherheiten
#----------------------------------------------------------------------
  if ikey == 2:
    if ti == True:
      clear_history()
    print()
    print("Eingabewerte 2:")
 
    while True:
      print("Fall 1: oben frei,unten eingespannt")
      print("Fall 2: oben & unten gelenkig eing.")
      print("Fall 3: oben gelenkig,unten eingesp.")
      print("Fall 4: oben & unten eingespannt")
      jey= input("Knickfall(1~4)? ")
      if jey in ("1","2","3","4"):
        break
    ifall= int(jey)

    Skeu = float(input("Knicksicherheit Euler? "))
    Sktet= float(input("Knicksicherheit Tetmajer? "))
    key=input("weiter mit Enter-Taste")

    choice()

#----------------------------------------------------------------------
#  F3 Rohr oder beliebiger Querschnitt?
#----------------------------------------------------------------------
  if ikey == 3:
    if ti == True:
      clear_history()
    print()
    print("Querschnitt:")
    print("Rohr    : 1")
    print("beliebig: 0")

    while True:
      jey= input("Querschnitt? ")
      if jey in ("0","1"):
        break
    irohr= int(jey)

    if irohr == 0:
      A= float(input("Flaeche A? "))
      I= float(input("Flaechentraegsm. I? "))
    else:
      Da= float(input("Aussendurchm. Da? "))
      Di= float(input("Innendurchm. Di? "))
     
    key=input("weiter mit Enter-Taste")
    
    choice()

#----------------------------------------------------------------------
#  F4 Material
#----------------------------------------------------------------------
  if ikey == 4:
    if ti == True:
      clear_history()
    print()
    print("Material:")
    print("1:S235,St37       2:S355,St52")
    print("3:Federstahl      4:Grauguss")
    print("5:Duralum.        6:Nadelholz")
    print("7:eigenes Material")

    while True:
      jey= input("Material Nr.(1~7)? ")
      if jey in ("1","2","3","4","5","6","7"):
        break
    imat= int(jey)
 
    if imat == 7:
      E = float(input("E-Modul E? "))
      Rp= float(input("Prop.grenze Rp? "))
 
    key=input("weiter mit Enter-Taste")

    choice()

#----------------------------------------------------------------------
#  F6 momentan definierte Werte
#----------------------------------------------------------------------
  if ikey == 6:
    if ti == True:
      clear_history()
    print()

    print("momentan def. Werte 1:")
    print("Kraft F= {0:.2f}".format(F))
    print("Stablaenge L= {0:.2f}".format(L)) 
    print("Knickfall= {0:.0f}".format(ifall))
    print("Knicksicherheit Euler= {0:.2f}".format(Skeu))
    print("Knicksicherheit Tetmajer= {0:.2f}".format(Sktet))
    if irohr == 1:
      print("Rohrabmessungen:")
      print("Aussend. Da= {0:.2f}".format(Da))  
      print("Innend. Di= {0:.2f}".format(Di)) 
    else:
      print("beliebiger Querschnitt")
      print("Flaeche A= {0:.2f}".format(A))  
      print("Traegh.moment I= {0:.2f}".format(I))    
    
    key=input("weiter mit Enter-Taste")

    if ti == True:
      clear_history()
    print()

    print("momentan def. Werte 2:")
    if imat == 1:
      print("Material ist S235/St37")
      E = 206000.0
      Rp= 205.0
    elif imat == 2:
      print("Material ist S355/St52")
      E = 206000.0
      Rp= 240.0
    elif imat == 3:
      print("Material ist Federstahl")        
      E = 206000.0
      Rp= 575.0
    elif imat == 4:
      print("Material ist Grauguss")
      E = 115000.0
      Rp= 154.0
    elif imat == 5:
      print("Material ist Duraluminium")
      E = 70000.0
      Rp= 200.0
    elif imat == 6:
      print("Material ist Nadelholz")
      E = 10000.0
      Rp= 9.0
    else:
      print("eigenes Material")

    print("E = {0:.0f}".format(E))
    print("Rp= {0:.0f}".format(Rp))

    key=input("weiter mit Enter-Taste")
   
    choice()

#----------------------------------------------------------------------
#  F7 Ergebnisse
#----------------------------------------------------------------------
  if ikey == 7:
    if ti == True:
      clear_history()

#======================================================================
#  Knicklaenge bestimmen
#======================================================================
    if ifall == 1:
      Lk= 2*L
    elif ifall == 2:
      Lk= L
    elif ifall == 3:
      Lk= 0.5*sqrt(2.0)*L
    else:
      Lk= 0.5*L

#======================================================================
#  E und Rp bestimmen, falls nicht eigenes Material
#======================================================================
    if imat == 1:
      E = 206000.0
      Rp= 205.0
    elif imat == 2:
      E = 206000.0
      Rp= 240.0
    elif imat == 3:
      E = 206000.0
      Rp= 575.0
    elif imat == 4:
      E = 115000.0
      Rp= 154.0
    elif imat == 5:
      E = 70000.0
      Rp= 200.0
    elif imat == 6:
      E = 10000.0
      Rp= 9.0

#======================================================================
#  Wenn Rohr: A und I berechnen
#======================================================================
    if irohr == 1:
      A= pi*(Da**2 - Di**2)/4.0
      I= pi*(Da**4 - Di**4)/64.0

#======================================================================
#  Traegheitsradius, Lambda und Lambda_Grenz berechnen
#======================================================================
    i   = sqrt(I/A)
    lam = Lk/i
    lamg= pi*sqrt(E/Rp)
    
    sigd= F/A

#======================================================================
#  Entscheiden, ob Euler- oder Tetmajer-Knickfall
#======================================================================
    if lam < lamg:
    # Tetmajer-Knickung
      if imat == 1:
        sigk= 310.0 - 1.14*lam
      elif imat == 2:
        sigk= 310.0 - 1.14*lam
      elif imat == 3:
        sigk= 335.0 - 0.62*lam
      elif imat == 4:
        sigk= 776.0 - 12.0*lam + 0.053*lam**2
      elif imat == 5:
        sigk= Rp*(1.0 - 0.2*(lam/lamg)**2)
      elif imat == 6:
        sigk= 29.3 - 0.194*lam
      else:
        sigk= Rp*(1.0 - 0.2*(lam/lamg)**2)
      SEu= sigk/sigd  # SEu wird fuer beide Faelle verwendet
    else:
    # Euler-Knickung
      sigk= (pi**2)*E/(lam**2)
      SEu= sigk/sigd

#======================================================================
#  Ergebnisse andrucken
#======================================================================
    print()
    print("Ergebnisse 1:")

    print("Querschnittsf. A= {0:.0f}".format(A))      
    print("Traegheitsmoment I= {0:.0f}".format(I))
    print("Knicklaenge Lk= {0:.1f}".format(Lk))
    print("Traegheitsradius i= {0:.1f}".format(i))
    print("Schlankheitsgrad lam= {0:.0f}".format(lam))
    print("Grenz-Schlankheitsg. lamg= {0:.0f}".format(lamg))
    print("Knickspannung sigk= {0:.0f}".format(sigk)) 
    print("Druckspannung sigd= {0:.0f}".format(sigd))  

    key=input("weiter mit Enter-Taste")

    if ti == True:
      clear_history()
    print()

    print("Ergebnisse 2:")

    if lam < lamg:
      print("Tetmajer-Knickung")
      print("SK= {0:.1f}".format(SEu)) 
      if SEu > Sktet:
        print("keine Knickung!")
      else:
        print("es knickt!")
    else:
      print("Euler-Knickung")
      print("SK= {0:.1f}".format(SEu)) 
      if SEu > Skeu:
        print("keine Knickung!")
      else:
        print("es knickt!")
  
    key=input("weiter mit Enter-Taste")
 
    choice()

#----------------------------------------------------------------------
#  F8 Exit
#----------------------------------------------------------------------
  if ikey == 8:
    print("Ende PYKNICK")
    break
  
